function HideField(field){
	if(field.closest(".field.holder")){
		field.closest(".field.holder").classList.add("hidden");
	}else{
		field.classList.add("hidden");
	}
}
function ShowField(field){
	if(field.closest(".field.holder")){
		field.closest(".field.holder").classList.remove("hidden");
	}else{
		field.classList.remove("hidden");
	}
}
function EnableField(field){
	if(field.closest(".field.holder")){
		field.closest(".field.holder").classList.remove("disabled");
	}else{
		field.classList.remove("disabled");
	}
	field.disabled = false;
}
function DisableField(field){
	if(field.closest(".field.holder")){
		field.closest(".field.holder").classList.add("disabled");
	}else{
		field.classList.add("disabled");
	}
	field.disabled = true;
}
function DisableValidation(field){
	field.setAttribute('disable-validations', '1');
	field.closest(".field.holder").classList.remove("error");
	if(field.closest(".field.holder").querySelector('.errormsg')){
		field.closest(".field.holder").querySelector('.errormsg').remove();
	};
	if(field.closest(".field.holder").querySelector('.errormark')){
		field.closest(".field.holder").querySelector('.errormark').classList.add('hidden');
	};
}
function EnableValidation(field){
	field.removeAttribute('disable-validations');
	if(field.closest(".field.holder").querySelector('.errormark')){
		field.closest(".field.holder").querySelector('.errormark').classList.remove('hidden');
	};
}
function CallFunction(name, field){
	console.log(name, field)
	if(typeof window[name] === 'function'){
		window[name](field)
	}
}

function SetupEvent(field, event, fn){
	let fields = field.closest("form").querySelectorAll("[name='"+field.getAttribute("name")+"']");
	if(fields){
		fields.forEach(f => {
			f.addEventListener(event, e => {
				fn();
			})
		});
	}
}

function GetValues(field){
	let fields = field.closest("form").querySelectorAll("[name='"+field.getAttribute("name")+"']");
	if(fields){
		let values = [];
		fields.forEach(f => {
			if(field.getAttribute('type') == 'checkbox' || field.getAttribute('type') == 'radio'){
				if(f.checked){
					values.push(f.value);
				}
			}else{
				if(f.value.length > 0){
					values.push(f.value);
				}
			}
		});
		return values;
	}

	return [];
}

function isEmpty(field){
	let values = GetValues(field);
	return (values.length == 0);
}

function HasValue(field, tvalues){
	let values = GetValues(field);
	let result = false;
	tvalues.forEach(v => {
		if(values.includes(v)){
			result = true;
			return;
		}
	});
	return result;
}