<?php
/*
Plugin Name: ChronoMyadmin
Plugin URI: https://www.chronoengine.com
Description: ChronoMyadmin will help you manage your WordPress database tables.
Version: 1.0.0
Author: Max & ChronoEngine.com Team
Author URI: https://www.chronoengine.com
License: GPL2
*/
// this is required for redirect to work
ob_start();

// if(!session_id()) {
// 	session_start();
// }

function chronomyadmin_ajax_call() {
	// Check if we are in the admin area and if a specific URL parameter exists
	if (is_admin() && isset($_GET['page']) && ($_GET['page'] == "chronomyadmin") && isset($_GET['output']) && ($_GET['output'] == "component")) {
	   chronomyadmin_page_content();
		exit();
	}
}
add_action('init', 'chronomyadmin_ajax_call');

// Hook to add a new menu page in the admin area
add_action('admin_menu', 'chronomyadmin_add_admin_page');

function chronomyadmin_add_admin_page() {
	// Use add_menu_page to add a new top-level menu
	add_menu_page(
		'ChronoMyadmin',  // Page title
		'ChronoMyadmin',     // Menu title
		'manage_options',    // Capability required to view this page
		'chronomyadmin',  // Menu slug (unique ID for the menu)
		'chronomyadmin_page_content', // Function to display page content
		'dashicons-admin-generic',       // Icon for the menu
		100                              // Position in the menu order
	);
}

// Function to display content on the custom admin page
function chronomyadmin_page_content($action = "") {
	require_once(__DIR__."/admin/extension.php");

	ChronoApp::Instance("chronomyadmin", "ChronoMyadmin")->processExtension($action);
}


// Hook for plugin activation
register_activation_hook(__FILE__, 'chronomyadmin_activation_function');

// Function that runs on plugin activation
function chronomyadmin_activation_function() {
	$sql = file_get_contents(__DIR__."/admin/sql/install.sql");
	
	// Create a custom database table
	global $wpdb;
	// $table_name = $wpdb->prefix . 'my_custom_table'; // Create table with WP prefix
	// $charset_collate = $wpdb->get_charset_collate();
	$sql = str_replace("#__", $wpdb->prefix, $sql);

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

	$statements = explode("CREATE ", $sql);

	foreach($statements as $statement){
		if(!empty(trim($statement))){
			dbDelta("CREATE ".$statement);
		}
	}
	// dbDelta($sql); // Run the SQL query to create the table
}


?>
